import { Component, ViewChild, TemplateRef, ElementRef, EventEmitter, Directive, Input, ComponentFactoryResolver, ViewContainerRef, Output, NgModule } from '@angular/core';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxBootstrapPopupPlaceholderComponent {
    /**
     * @return {?}
     */
    get inserted() {
        return this._inserted;
    }
    /**
     * @param {?} inserted
     * @return {?}
     */
    set inserted(inserted) {
        this._inserted = inserted;
        if (inserted instanceof TemplateRef) {
            this._template = inserted;
        }
        else {
            this._template = this.defaultTemplate;
        }
    }
    /**
     * @return {?}
     */
    get template() {
        return this._template;
    }
}
NgxBootstrapPopupPlaceholderComponent.decorators = [
    { type: Component, args: [{
                selector: 'ngx-bootstrap-popup-placeholder',
                template: `<div #insertedContent>
    <ng-container *ngTemplateOutlet="template"></ng-container>
  </div>
  <ng-template #defaultTemplate>{{inserted}}</ng-template>`
            }] }
];
NgxBootstrapPopupPlaceholderComponent.propDecorators = {
    defaultTemplate: [{ type: ViewChild, args: ['defaultTemplate',] }],
    insertedContent: [{ type: ViewChild, args: ['insertedContent',] }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @abstract
 */
class NgxBootstrapPopup {
    /**
     * @param {?} _elementRef
     * @param {?} _cfr
     * @param {?} _vcr
     */
    constructor(_elementRef, _cfr, _vcr) {
        this._elementRef = _elementRef;
        this._cfr = _cfr;
        this._vcr = _vcr;
        this.events = new EventEmitter();
        this.titleComponentRef = null;
        this.contentComponentRef = null;
        this.bsEventListener = null;
        this.clickDismissListener = null;
    }
    /**
     * @return {?}
     */
    getOptions() {
        /** @type {?} */
        const options = Object.assign({}, this.options);
        if (this.title) {
            this.titleComponentRef = this.getPlaceholderComponent();
            this.titleComponentRef.instance.inserted = this.title;
            options.title = this.titleComponentRef.instance.insertedContent.nativeElement;
            options.html = true;
        }
        if (this.content) {
            this.contentComponentRef = this.getPlaceholderComponent();
            this.contentComponentRef.instance.inserted = this.content;
            options.content = this.contentComponentRef.instance.insertedContent.nativeElement;
            options.html = true;
        }
        return options;
    }
    /**
     * @return {?}
     */
    get cfr() {
        return this._cfr;
    }
    /**
     * @return {?}
     */
    get vcr() {
        return this._vcr;
    }
    /**
     * @return {?}
     */
    get el() {
        return this._elementRef.nativeElement;
    }
    /**
     * @return {?}
     */
    get $el() {
        return jQuery(this.el);
    }
    /**
     * @return {?}
     */
    get bsInstance() {
        return this.$el.data('bs.' + this.popupType);
    }
    /**
     * @return {?}
     */
    get jQueryEvents() {
        return ['show', 'inserted', 'shown', 'hide', 'hidden'].map((/**
         * @param {?} t
         * @return {?}
         */
        t => `${t}.bs.${this.popupType}`)).join(' ');
    }
    /**
     * @return {?}
     */
    ngOnInit() {
        this.create();
    }
    /**
     * @return {?}
     */
    updateTitle() {
        if (this.titleComponentRef && this.title) {
            this.titleComponentRef.instance.inserted = this.title;
            this.update();
        }
    }
    /**
     * @return {?}
     */
    updateContent() {
        if (this.contentComponentRef && this.content) {
            this.contentComponentRef.instance.inserted = this.content;
            this.update();
        }
    }
    /**
     * @return {?}
     */
    updateEnabled() {
        if (this.bsInstance) {
            if (this.enabled) {
                this.enable();
            }
            else {
                this.disable();
            }
        }
    }
    /**
     * @return {?}
     */
    ngOnDestroy() {
        this.$el[this.popupType]('dispose');
        this.$el.off(this.jQueryEvents, this.bsEventListener);
        if (this.clickDismissListener) {
            jQuery('body').off('click focusin', this.clickDismissListener);
        }
        if (this.titleComponentRef) {
            this.titleComponentRef.destroy();
        }
        if (this.contentComponentRef) {
            this.contentComponentRef.destroy();
        }
    }
    /**
     * @return {?}
     */
    create() {
        this.bsEventListener = (/**
         * @param {?} event
         * @return {?}
         */
        (event) => {
            if (this.dismissOnClickOutside && event.type === 'shown') {
                this.clickDismissListener = (/**
                 * @param {?} clickEvent
                 * @return {?}
                 */
                (clickEvent) => {
                    if (this.bsInstance.tip.contains(clickEvent.target)) {
                        return;
                    }
                    jQuery('body').off('click focusin', this.clickDismissListener);
                    this.clickDismissListener = null;
                    this.hide();
                });
                jQuery('body').on('click focusin', this.clickDismissListener);
            }
            this.events.emit(event);
        });
        this.$el.on(this.jQueryEvents, this.bsEventListener);
        /** @type {?} */
        const options = this.getOptions();
        this.$el[this.popupType](options);
        this.updateEnabled();
    }
    /**
     * @return {?}
     */
    getPlaceholderComponent() {
        /** @type {?} */
        const factory = this.cfr.resolveComponentFactory(NgxBootstrapPopupPlaceholderComponent);
        return this.vcr.createComponent(factory, 0);
    }
    /**
     * @return {?}
     */
    show() {
        this.$el[this.popupType]('show');
    }
    /**
     * @return {?}
     */
    hide() {
        this.$el[this.popupType]('hide');
    }
    /**
     * @return {?}
     */
    toggle() {
        this.$el[this.popupType]('toggle');
    }
    /**
     * @return {?}
     */
    enable() {
        this.$el[this.popupType]('enable');
    }
    /**
     * @return {?}
     */
    disable() {
        this.$el[this.popupType]('disable');
    }
    /**
     * @return {?}
     */
    toggleEnabled() {
        this.$el[this.popupType]('toggleEnabled');
    }
    /**
     * @return {?}
     */
    update() {
        this.$el[this.popupType]('update');
    }
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxBootstrapTooltipDirective extends NgxBootstrapPopup {
    /**
     * @param {?} elementRef
     * @param {?} cfr
     * @param {?} vcr
     */
    constructor(elementRef, cfr, vcr) {
        super(elementRef, cfr, vcr);
        this.tooltipEnabled = true;
        this.tooltipOptions = null;
        this.popupType = 'tooltip';
        this.tooltipEvents = this.events;
    }
    /**
     * @return {?}
     */
    get title() {
        return this.tooltipTitle || null;
    }
    /**
     * @return {?}
     */
    get content() {
        return null;
    }
    /**
     * @return {?}
     */
    get options() {
        return this.tooltipOptions || {};
    }
    /**
     * @return {?}
     */
    get enabled() {
        return this.tooltipEnabled !== false;
    }
    /**
     * @return {?}
     */
    get dismissOnClickOutside() {
        return this.tooltipDismissOnClickOutside === true;
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if (changes.tooltipEnabled !== undefined) {
            this.updateEnabled();
        }
        if (changes.tooltipTitle) {
            this.updateTitle();
        }
    }
}
NgxBootstrapTooltipDirective.decorators = [
    { type: Directive, args: [{
                selector: '[ngxBootstrapTooltip]'
            },] }
];
/** @nocollapse */
NgxBootstrapTooltipDirective.ctorParameters = () => [
    { type: ElementRef },
    { type: ComponentFactoryResolver },
    { type: ViewContainerRef }
];
NgxBootstrapTooltipDirective.propDecorators = {
    tooltipTitle: [{ type: Input }],
    tooltipEnabled: [{ type: Input }],
    tooltipDismissOnClickOutside: [{ type: Input }],
    tooltipOptions: [{ type: Input }],
    tooltipEvents: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxBootstrapPopoverDirective extends NgxBootstrapPopup {
    /**
     * @param {?} elementRef
     * @param {?} cfr
     * @param {?} vcr
     */
    constructor(elementRef, cfr, vcr) {
        super(elementRef, cfr, vcr);
        this.popoverOptions = null;
        this.popoverEnabled = true;
        this.popupType = 'popover';
        this.popoverEvents = this.events;
    }
    /**
     * @return {?}
     */
    get title() {
        return this.popoverTitle || null;
    }
    /**
     * @return {?}
     */
    get content() {
        return this.popoverContent || null;
    }
    /**
     * @return {?}
     */
    get options() {
        return this.popoverOptions || {};
    }
    /**
     * @return {?}
     */
    get enabled() {
        return this.popoverEnabled !== false;
    }
    /**
     * @return {?}
     */
    get dismissOnClickOutside() {
        return this.popoverDismissOnClickOutside === true;
    }
    /**
     * @param {?} changes
     * @return {?}
     */
    ngOnChanges(changes) {
        if (changes.popoverEnabled !== undefined) {
            this.updateEnabled();
        }
        if (changes.popoverTitle !== undefined) {
            this.updateTitle();
        }
        if (changes.popoverContent !== undefined) {
            this.updateContent();
        }
    }
}
NgxBootstrapPopoverDirective.decorators = [
    { type: Directive, args: [{
                selector: '[ngxBootstrapPopover]'
            },] }
];
/** @nocollapse */
NgxBootstrapPopoverDirective.ctorParameters = () => [
    { type: ElementRef },
    { type: ComponentFactoryResolver },
    { type: ViewContainerRef }
];
NgxBootstrapPopoverDirective.propDecorators = {
    popoverContent: [{ type: Input }],
    popoverTitle: [{ type: Input }],
    popoverOptions: [{ type: Input }],
    popoverEnabled: [{ type: Input }],
    popoverDismissOnClickOutside: [{ type: Input }],
    popoverEvents: [{ type: Output }]
};

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
class NgxBootstrapPopupModule {
}
NgxBootstrapPopupModule.decorators = [
    { type: NgModule, args: [{
                declarations: [
                    NgxBootstrapPopoverDirective,
                    NgxBootstrapTooltipDirective,
                    NgxBootstrapPopupPlaceholderComponent
                ],
                imports: [
                    CommonModule
                ],
                exports: [
                    NgxBootstrapPopoverDirective,
                    NgxBootstrapTooltipDirective
                ],
                entryComponents: [
                    NgxBootstrapPopupPlaceholderComponent
                ]
            },] }
];

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NgxBootstrapTooltipDirective, NgxBootstrapPopoverDirective, NgxBootstrapPopupModule, NgxBootstrapPopup as ɵa, NgxBootstrapPopupPlaceholderComponent as ɵb };

//# sourceMappingURL=nowzoo-ngx-bootstrap-popup.js.map