import { OnInit, OnDestroy, EventEmitter, TemplateRef, ElementRef, ComponentRef, ViewContainerRef, ComponentFactoryResolver } from '@angular/core';
import { NgxBootstrapPopupPlaceholderComponent } from './ngx-bootstrap-popup-placeholder.component';
import { IPopupOptions } from './shared';
export declare abstract class NgxBootstrapPopup implements OnInit, OnDestroy {
    private _elementRef;
    private _cfr;
    private _vcr;
    protected events: EventEmitter<Event>;
    abstract popupType: 'popover' | 'tooltip';
    abstract title: string | TemplateRef<any>;
    abstract content: string | TemplateRef<any>;
    abstract options: IPopupOptions;
    abstract enabled: boolean;
    abstract dismissOnClickOutside: boolean;
    titleComponentRef: ComponentRef<NgxBootstrapPopupPlaceholderComponent>;
    contentComponentRef: ComponentRef<NgxBootstrapPopupPlaceholderComponent>;
    bsEventListener: any;
    clickDismissListener: any;
    constructor(_elementRef: ElementRef, _cfr: ComponentFactoryResolver, _vcr: ViewContainerRef);
    getOptions(): any;
    readonly cfr: ComponentFactoryResolver;
    readonly vcr: ViewContainerRef;
    readonly el: HTMLElement;
    readonly $el: any;
    readonly bsInstance: any;
    readonly jQueryEvents: string;
    ngOnInit(): void;
    updateTitle(): void;
    updateContent(): void;
    updateEnabled(): void;
    ngOnDestroy(): void;
    create(): void;
    getPlaceholderComponent(): ComponentRef<NgxBootstrapPopupPlaceholderComponent>;
    show(): void;
    hide(): void;
    toggle(): void;
    enable(): void;
    disable(): void;
    toggleEnabled(): void;
    update(): void;
}
